<?php

namespace Modules\Order\Requests\Web;

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\Rule;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;
use Modules\User\Enums\AccountStatusEnum;
use Modules\User\Services\AccountService;

class CheckoutAddressRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $account = new AccountService();
        $user = $account->getAccount();
        if (request('locationType') == 'newLocation')
        {
            $rules =
                [
                    'name'=>[
                        'required'
                    ],
                    'city_id'=>[
                        'required',
                        'exists:cities,id'
                    ],
                    'area_id'=>[
                        'required',
                        'exists:areas,id'
                    ],
                    'address'=>'required',

                ];
            if (is_null(request('latitude')) && is_null(request('longitude')))
            {
                $rules['map'] = 'required';
            }
        }
        else
        {

            $rules =
            [
                'address_id'=>[
                    'required',
                    Rule::exists('addresses','id')->where('user_status',$user['status'])->where('user_id',$user['user']->id)->whereNull('deleted_at')
                ]
            ];
        }
        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {

        $attributes= [
            'name' => __('web.name'),
            'email' => __('users.email'),
            'phone' => __('users.phone'),
            'country_id' => __('web.country_id'),
            'city_id' => __('web.city_id'),
            'address' => __('web.address'),
            'map' => __('web.map'),
            'address_id' => __('web.address_id'),
        ];
        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
